package pp.s1184725.boppi;

public class Variable<T> {
	private final T type;
	private final int offset;
	
	public Variable(T type, int offset) {
		this.type = type;
		this.offset = offset;
	}
	
	public T getType() {
		return type;
	}
	
	public int getOffset() {
		return offset;
	}
	
	@Override
	public String toString() {
		return type.toString()+" @ "+offset;
	}
}
